<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>std - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="file.html">file</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="file.html#.readDir">readDir</a></li><li data-type='method' style='display: none;'><a href="file.html#.getFileTime">getFileTime</a></li><li data-type='method' style='display: none;'><a href="file.html#.path">path</a></li><li data-type='method' style='display: none;'><a href="file.html#.exists">exists</a></li><li data-type='method' style='display: none;'><a href="file.html#.load">load</a></li><li data-type='method' style='display: none;'><a href="file.html#.save">save</a></li><li data-type='method' style='display: none;'><a href="file.html#.gnuplot">gnuplot</a></li></ul></li><li><a href="http.html">http</a></li><li><a href="python.html">python</a></li><li><a href="regex.html">regex</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="regex.html#.regexMatch">regexMatch</a></li><li data-type='method' style='display: none;'><a href="regex.html#.regexIndexes">regexIndexes</a></li><li data-type='method' style='display: none;'><a href="regex.html#.regexReplace">regexReplace</a></li><li data-type='method' style='display: none;'><a href="regex.html#.regexSplit">regexSplit</a></li></ul></li><li><a href="stats.html">stats</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="stats.html#.random">random</a></li><li data-type='method' style='display: none;'><a href="stats.html#.getStat">getStat</a></li><li data-type='method' style='display: none;'><a href="stats.html#.getStatValue">getStatValue</a></li><li data-type='method' style='display: none;'><a href="stats.html#.getDivergence">getDivergence</a></li><li data-type='method' style='display: none;'><a href="stats.html#.plotHistogram">plotHistogram</a></li><li data-type='method' style='display: none;'><a href="stats.html#.plotStatCurve">plotStatCurve</a></li><li data-type='method' style='display: none;'><a href="stats.html#.plotStatBoxes">plotStatBoxes</a></li></ul></li><li><a href="std.html">std</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="std.html#.echo">echo</a></li><li data-type='method' style='display: none;'><a href="std.html#.alert">alert</a></li><li data-type='method' style='display: none;'><a href="std.html#.argv">argv</a></li><li data-type='method' style='display: none;'><a href="std.html#.system">system</a></li><li data-type='method' style='display: none;'><a href="std.html#.wfork">wfork</a></li><li data-type='method' style='display: none;'><a href="std.html#.wfork">wfork</a></li></ul></li><li><a href="time.html">time</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="time.html#.sleep">sleep</a></li><li data-type='method' style='display: none;'><a href="time.html#.now">now</a></li><li data-type='method' style='display: none;'><a href="time.html#.nowISO">nowISO</a></li></ul></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">std</h1>
    

    




<section>

<header>
    
        <h2>
        
            std
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="std"><span class="type-signature"></span>factory std<span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Specifies standard functions of string formating, assertion verification and program line argument.</p>
<ul>
<li>These functions are accessible via the <code>aidesys::</code> prefix.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>






























        
        </div>
    

    

    

    
    
    

     

    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    <h4 class="name" id=".echo"><span class="type-signature type-signature-static">(static) </span>echo<span class="signature">(message, &hellip;parameters)</span><span class="type-signature"> &rarr; {string}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns a formatted message à-la printf.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>message</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            

            <td class="description last"><p>The message, a string format à-la printf with more parameters if used.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>parameters</code></td>
            

            <td class="type">
            
                
<span class="param-type">anything</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                    &lt;repeatable><br>
                
                </td>
            

            

            <td class="description last"><p>Any message parameters.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The formated message.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">string</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id=".alert"><span class="type-signature type-signature-static">(static) </span>alert<span class="signature">(condition<span class="signature-attributes">opt</span>, thrown, message, &hellip;parameters<span class="signature-attributes">opt</span>)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Checks a condition at run-time and throws a fatal error exception and/or dumps a warning if not verified.
Examples:</p>
<ul>
<li><code>aidesys::alert(x == 0, &quot;numerical-error&quot;, &quot;division by zero&quot;);</code> to print a warning on <code>stderr</code> and stop the program if <code>x==0</code>.</li>
<li><code>aidesys::alert(x == 0, &quot; numerical-error&quot;, &quot;division by zero&quot;);</code> to print a warning on <code>stderr</code> without stopping the program.</li>
<li><code>aidesys::alert(verbose, &quot;&quot;, &quot;using aidesys::alert at %.0f&quot;, aidesys::now());</code> to simply echo a message if verbose.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>condition</code></td>
            

            <td class="type">
            
                
<span class="param-type">bool</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>true</code>
                
                </td>
            

            <td class="description last"><p>If the condition is true, an alert is issued.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>thrown</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>The name of the thrown exception if the alert is raised.</p>
<ul>
<li>Typical exception are:
<ul>
<li><code>illegal-argument</code>: when a method or function receives an argument with a spurious value.</li>
<li><code>IO-exception</code>:     when an input or output operation fails.</li>
<li><code>numerical-error</code>:  when a numerical error occurs.</li>
<li><code>illegal-state</code>:    when detecting an unexpected condition (a bug) at some point in the code.
<ul>
<li>If the name starts with a space (e.g., <code> warning</code>) a simple warning is printed on <code>stderr</code>.</li>
<li>Otherwise a <code>aide::exception</code> expection is thrown.</li>
<li>In both case the backtrace progam stack is dumped, if compiler with <code>-g</code> option.</li>
</ul>
</li>
</ul>
</li>
<li>Typical non fatal messages are:
<ul>
<li>``:         to simply print information of <code>stdout</code>.</li>
<li><code> warning</code>: (i.e., prefixed by a space) to print a warning on <code>stderr</code>, with the program stack.</li>
<li><code>  warning</code>: (i.e., prefixed by two spaces) to print a warning on <code>stderr</code>, without the program stack.</li>
</ul>
</li>
</ul></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>message</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>The message, a string format à-la printf with more parameters if used.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>parameters</code></td>
            

            <td class="type">
            
                
<span class="param-type">anything</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                    &lt;repeatable><br>
                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>Any message parameters.</p></td>
        </tr>

    
    </tbody>
</table>














<h5 class="h5-throws">Throws:</h5>

        

<dl>
    <dt>
        <div class="param-desc usertext">
        <p>A <code>aide::exception</code> <a href="http://www.cplusplus.com/reference/exception/exception">std::exception</a> object</p>
<ul>
<li>The <code>what()</code> method returns <code>&quot;$thrown:$message&quot;</code> concatenating the expection label and related message.</li>
</ul>
<pre class="prettyprint source"><code>// For instance the following construct catches a potential exception and reformulates the message:
</code></pre>
<p>try {
aidesys::regexReplace(string, parseInput, parseOutput);
} catch(std::exception&amp; e) {
aidesys::alert(true, &quot;illegal-argument&quot;, &quot;in symboling::RecordType::RecordType bad regex syntax: '%s'&quot;, e.what());
}</p>
<pre class="prettyprint source"><code></code></pre>
        </div>
    </dt>
    <dd></dd>
    <dt>
        <dl class="param-type">
            <dt>
                Type
            </dt>
            <dd>
                
<span class="param-type">exception</span>



            </dd>
        </dl>
    </dt>
    <dd></dd>
</dl>


    


<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The condition value, unless an exception occurs.</p>
</div>



    



        
            

    

    <h4 class="name" id=".argv"><span class="type-signature type-signature-static">(static) </span>argv<span class="signature">()</span><span class="type-signature"> &rarr; {Array.&lt;string>}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns the program command line.</p>
<ul>
<li>Corresponds to the <code>int main(int argc, const char *argv[])</code> parameters.</li>
<li>On OS not supporting the &quot;/proc/&quot; pseudo-filesystem (i.e., MasOS or Windows) the following construct must be used:</li>
</ul>
<pre class="prettyprint source"><code>   int main(int argc, const char *argv[]) {
     aidesys::argv(argc, argv);
     // main routine code
   }
</code></pre></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>



























<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>A <code>const std::vector&lt;std::string&gt;</code> with the program command line arguments.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Array.&lt;string></span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id=".system"><span class="type-signature type-signature-static">(static) </span>system<span class="signature">(command, noline<span class="signature-attributes">opt</span>, timeout<span class="signature-attributes">opt</span>)</span><span class="type-signature"> &rarr; {string}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Executes a system command and returns the stdout.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>command</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>The command to execute. The command path must be absolute (e.g. <tt>/bin/pwd</tt> not <tt>pwd</tt>).</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>noline</code></td>
            

            <td class="type">
            
                
<span class="param-type">bool</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>false</code>
                
                </td>
            

            <td class="description last"><p>If true replaces new lines and spaces by a unique space.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>timeout</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>0</code>
                
                </td>
            

            <td class="description last"><p>Optional timeout in milliseconds.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The command result, or an error message.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">string</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id=".wfork"><span class="type-signature type-signature-static">(static) </span>wfork<span class="signature">(runner, what, delay)</span><span class="type-signature"> &rarr; {pid}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Implements the execution of a runner in a child process.</p>
<ul>
<li>The function corresponds to <a href="https://www.w3schools.com/js/js_timing.asp">setTimeout() and setInterval()</a> javascript timing methods.</li>
<li>Its <a href="https://gitlab.inria.fr/line/aide-group/aidesys/-/raw/master/src/wfork.cpp">implementation</a> is quite straightforward and provides a very basic example of using the <a href="https://www.geeksforgeeks.org/fork-system-call">C/C++ fork</a> mechanism.</li>
<li>The method returns immediatly.</li>
<li>The child process always exit with a '0' error code.</li>
<li>All childs processes are properly killed when program stops.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>runner</code></td>
            

            <td class="type">
            
                
<span class="param-type">function</span>



            
            </td>

            

            

            <td class="description last"><p>A <code>int()</code> function that returns a status and print on stdout.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>what</code></td>
            

            <td class="type">
            
                
<span class="param-type">char</span>



            
            </td>

            

            

            <td class="description last"><p>Either:</p>
<ul>
<li>'t' for the setTimeout mechanism, i.e, executes a the runner, after waiting a specified number of milliseconds (this is the default behavior).</li>
<li>'i' for the setInterval mechanism, i.e, repeats the execution of the runner continuously, after waiting a 1st delay, while the <code>runner()</code> return '0' (no error).</li>
</ul></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>delay</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>The timeout or interval delay in millisecond.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The runner process <a href="https://ftp.gnu.org/old-gnu/Manuals/glibc-2.2.3/html_node/libc_554.html">pid</a>:</p>
<ul>
<li>It allows to send a signal to the child process, using <code>wfork_kill(pid);</code></li>
</ul>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">pid</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id=".wfork"><span class="type-signature type-signature-static">(static) </span>wfork<span class="signature">(runner, timeout<span class="signature-attributes">opt</span>, status<span class="signature-attributes">opt</span>)</span><span class="type-signature"> &rarr; {string}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Implements the execution of a runner in a child process, returning the stdout.</p>
<ul>
<li>The function is called with prefix <code>aidesys::wfork(·)</code>.</li>
<li>Typical usage:</li>
</ul>
<pre class="prettyprint source"><code>struct MyClass {
 // Runner returned status
 unsigned int status;
 // Here the runner is an instance method, with some parameter.
 int runner(String name) { cout &lt;&lt; &quot;Hello &quot; + name + &quot;!&quot;; return 0; }
 // Calls the runner in a child process with timeout
 std::string run(String name, unsigned int timeout) {
   // The lambda construction allows to use it capturing the related parameters.
   return aidesys::wfork([this, name]() { return runner(name); }, timeout, &status);
../..
</code></pre></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>runner</code></td>
            

            <td class="type">
            
                
<span class="param-type">function</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>A <code>int()</code> function that returns a status and print on stdout.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>timeout</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>0</code>
                
                </td>
            

            <td class="description last"><p>An optional timeout value, in millisecond. No timeout if the value is <code>0</code>.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>status</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>NULL</code>
                
                </td>
            

            <td class="description last"><p>An optional <code>unsigned int *status</code> pointer to get the runner return status:</p>
<ul>
<li><code>0</code> : if no error;</li>
<li><code>256</code>: if in timeout;</li>
<li>otherwise, an error code between 1 and 255.</li>
</ul></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The runner process sdtout.</p>
<ul>
<li>The method returns after the runner process ends or is on timeout.</li>
</ul>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">string</span>



    </dd>
</dl>

    



        
    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>